#ifndef _INCLUDE_M_H
#define _INCLUDE_M_H

/* Defines/Macros for machine */
#define REG_A 0
#define REG_B 1
#define OP_SET 0
#define OP_ADD 1
#define OP_MUL 2
#define OP_END 3
#define ERR_INVALID_INSTRUCTION 1
#define ERR_HALT -1

struct ContextM_s;

/* Function call required for an opcode */
typedef void (*OPCODEM)(struct ContextM_s *m);

/* Structure of machine state */
typedef struct ContextM_s
{
   unsigned char regs[2]; /* registers A and B */
   int err;  /* error state */
   unsigned char *cip; /* instruction pointer */
   unsigned char *bytecode; /* machine code */
} ContextM;

int Initialize_M(ContextM *m);

int Execute_M(ContextM *m, int *err);

#endif //_INCLUDE_M_H

